/****************************************************************************
			   CONORDER.H (TSPHEUR.EXE)

	    Connection order rouintes are contained in this unit.
 ****************************************************************************/

/* connection order pin record type
 */
typedef struct {
    INT x, y, z;
    INT conns[9];
    INT ring, level;
    INT srctrm;
} CON_CITYTYPE;

/* connection order wire record type
 */
typedef struct {
    INT cfrom, cto;
    INT distance;
    CHAR eligible, exclude;
} CON_WIRETYPE;

/* length macros */
#define CON_CITYMAX 150
#define CON_WIREMAX 12000
#define CON_MAXLEN  9999999L

/* prototypes */
VOID  con_alloc( VOID );
VOID  con_dealloc( VOID );
LONG  con_heuristic( INT );
LONG  con_hookup( INT );
VOID  con_initcities( INT );
INT   con_levelok( INT, INT );
VOID  con_makewires( VOID );
LONG  con_mintree( VOID );
LONG  con_neighbor( VOID );
VOID  con_randcities( VOID );
VOID  con_reset( VOID );
VOID  con_setring( INT, INT );
VOID  con_sortwires( VOID );
VOID  con_sortshift( INT, INT );
INT   con_wireok( INT, INT, INT );


