#if !defined(__ppclntap_h)              // Sentry, use file only if it's not already included.
#define __ppclntap_h

/*  Project popclnt
    
    SUBSYSTEM:    popclnt.exe Application
    FILE:         ppclntap.hpp
    AUTHOR:       Robert A. Duffy


    OVERVIEW
    ========
    Class definition for TPopClientApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "tppmdicl.hpp"

#include "ppclntap.rh"            // Definition of all resources.


//{{TApplication = TPopClientApp}}
class TPopClientApp : public TApplication {
private:

    void SetupSpeedBar (TDecoratedMDIFrame *frame);
public:
    TStatusBar* pStatusBar;
    TPopClientApp ();
    virtual ~TPopClientApp ();

    TOpenSaveDialog::TData  FileData;                   // Data to control open/saveas standard dialog.

    TPopMDIClient  *mdiClient;

//{{TPopClientAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
//{{TPopClientAppVIRTUAL_END}}

//{{TPopClientAppRSP_TBL_BEGIN}}
protected:
    void CmHelpAbout ();
//{{TPopClientAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TPopClientApp);
};    //{{TPopClientApp}}


#endif                                      // __ppclntap_h sentry.
